#ifndef WHL
#define WHL
#include "WTL.H"
#define CONST_SQRT_2     0.7071067811865475728
//======================================================================
// 
// 
scomplex U_Haar(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM(CONST_SQRT_2,0);
    S.Mas[1]=SET_ELEM(CONST_SQRT_2,0);
    for(i=2;i<k;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
// 
scomplex V_Haar(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM(CONST_SQRT_2,0);
    S.Mas[1]=SET_ELEM(-CONST_SQRT_2,0);
    for(i=2;i<k;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
//  :
scomplex* Filtrs_Haar(integer k,integer p) {
    TRIG_FVARS
    WORK(Haar)
    FREE_MEMORY
    return Filtr;
}
//======================================================================
//         
integer Haar_MAX_ITER(integer k) {
    integer p=0;
    real d=k;
    while(1) {
		d/=2;
		if(d==(integer)d) p++;
		else break;
	}
    if(p) return p-1;
    return p;
};
#endif
